//
//  SettingViewController.m
//  TOSR Bluetooth
//
//  Created by zhengjunli on 15/4/18.
//  Copyright (c) 2015年 leekey. All rights reserved.
//

#import "SettingViewController.h"
#define kAlphaNum   @"ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789"

@interface SettingViewController ()<UITextFieldDelegate,UIScrollViewDelegate>
{
    UITextField *activeTextField;
    CGFloat orightOffset;
    BOOL isShowKeyboard;
}

@property(nonatomic,strong) UIScrollView *nameScrollView;
@property(nonatomic,strong) UIScrollView *modeScrollView;
@property(nonatomic,strong) UIScrollView *mainScrollView;
@end

@implementation SettingViewController
@synthesize delegate;

- (void)viewDidLoad {
    [super viewDidLoad];
    self.title = @"Name";
    
    [self setUpView];
    int index = 100;
    for (; index<112; index++) {
        UITextField *re1 = (UITextField*)[self.nameScrollView viewWithTag:index];
        NSString *namekey = [NSString stringWithFormat:@"name%d",index];
        NSString *name = [[NSUserDefaults standardUserDefaults] objectForKey:namekey];
        if(name ==nil || [name isEqualToString:@""]){
            name = [NSString stringWithFormat:@"Relay%d",index-100+1];
        }
        NSString *modekey = [NSString stringWithFormat:@"mode%d",index];
        
        UISwitch *swi = (UISwitch*)[self.modeScrollView viewWithTag:index];
        swi.on = [[NSUserDefaults standardUserDefaults] boolForKey:modekey];
        [re1 setText:name];
    }
    
    self.navigationItem.leftBarButtonItem = [[UIBarButtonItem alloc]initWithTitle:@"Back" style:UIBarButtonItemStylePlain target:self action:@selector(onBack)];
    
}

-(void)switchAction:(id)sender
{
    UISwitch *switchButton = (UISwitch*)sender;
    BOOL isButtonOn = [switchButton isOn];
    int tag = (int)switchButton.tag;
    if([delegate respondsToSelector:@selector(onSettingMode:mode:)]){
        [delegate onSettingMode:tag mode:isButtonOn];
    }
}

-(void)setUpView{
     [[NSNotificationCenter defaultCenter] addObserver:self selector:@selector(keyboardDidChangeFrame:) name:UIKeyboardWillChangeFrameNotification object:nil];
    self.navigationController.navigationBar.translucent = NO;
    UIImageView *bg = [[UIImageView alloc]initWithImage:[UIImage imageNamed:@"bg.jpg"]];
    bg.frame = self.view.frame;
    [self.view addSubview:bg];
    
    UIScrollView *scrollView = [[UIScrollView alloc]initWithFrame:self.view.frame];
    scrollView.contentSize = CGSizeMake(self.view.width*2, self.view.height);
    scrollView.showsHorizontalScrollIndicator = NO;
    scrollView.pagingEnabled = YES;
    scrollView.delegate = self;
    self.mainScrollView = scrollView;
    [self.view addSubview:scrollView];
    
    UIView *nameView = [[UIView alloc]initWithFrame:self.view.frame];
    [scrollView addSubview:nameView];
    
    UIView *modeView = [[UIView alloc]init];
    modeView.frame = CGRectMake(self.view.width, 0, self.view.width, self.view.height);
    [scrollView addSubview:modeView];
    
    
    CGFloat leftMargin = 30.f;
    CGFloat rightMargin = 20.f;
    CGFloat topMargin = 15.f;
    CGFloat margin = 20.f;
    _nameScrollView = [[UIScrollView alloc]initWithFrame:nameView.bounds];
    _nameScrollView.delegate = self;
    [nameView addSubview:_nameScrollView];
    
    CGFloat height = 30.f;
    for(int index = 0;index<12;index++){
        UILabel *titleLabel = [[UILabel alloc]init];
        titleLabel.x = leftMargin;
        titleLabel.width = 70.f;
        titleLabel.height = height;
        titleLabel.textColor = [UIColor whiteColor];
        titleLabel.y = topMargin+(margin+height)*index;
        titleLabel.text = [NSString stringWithFormat:@"Relay%d",index+1];
        [_nameScrollView addSubview:titleLabel];
        
        UITextField *text = [[UITextField alloc]init];
        
        text.x = CGRectGetMaxX(titleLabel.frame) + margin/2;
        text.width = self.view.width - rightMargin - text.x;
        text.height = height;
        text.textAlignment = NSTextAlignmentCenter;
        text.delegate = self;
        text.textColor =[UIColor whiteColor];
        text.y = topMargin + (margin+height)*index;
        text.tag = 100+index;
        text.background = [UIImage imageNamed:@"input_bg"];
        [_nameScrollView addSubview:text];
    }
    UIView *last = _nameScrollView.subviews.lastObject;
    _nameScrollView.contentSize = CGSizeMake(self.view.width, CGRectGetMaxY(last.frame)+margin+60);
    
    orightOffset = _nameScrollView.contentOffset.y;
    _modeScrollView = [[UIScrollView alloc]initWithFrame:modeView.bounds];
    [modeView addSubview:_modeScrollView];
    for(int index = 0;index<12;index++){
        UILabel *titleLabel = [[UILabel alloc]init];
        titleLabel.x = leftMargin;
        titleLabel.width = 60.f;
        titleLabel.height = height;
        titleLabel.textColor = [UIColor whiteColor];
        titleLabel.y = topMargin+(margin+height)*index;
        titleLabel.text = [NSString stringWithFormat:@"Relay%d",index+1];
        [_modeScrollView addSubview:titleLabel];
        
        
        UILabel *Latching = [[UILabel alloc]init];
        Latching.width = 60.f;
        Latching.height = height;
        Latching.textAlignment = NSTextAlignmentCenter;
        Latching.font = [UIFont systemFontOfSize:13.f];
        Latching.x =CGRectGetMaxX(titleLabel.frame) + margin/2;
        Latching.y = topMargin + (margin+height)*index;
        Latching.text = @"Latching";
        Latching.textColor = [UIColor whiteColor];
        [_modeScrollView addSubview:Latching];
        
        UISwitch *modeSwitch = [[UISwitch alloc]init];
        modeSwitch.x =CGRectGetMaxX(Latching.frame) + margin/2;
        modeSwitch.y = topMargin + (margin+height)*index;
        modeSwitch.tag = 100+index;
        [modeSwitch addTarget:self action:@selector(switchAction:) forControlEvents:UIControlEventValueChanged];
        [_modeScrollView addSubview:modeSwitch];
        

        UILabel *Momentary = [[UILabel alloc]init];
        Momentary.textAlignment = NSTextAlignmentCenter;
        Momentary.height = height;
        Momentary.font = [UIFont systemFontOfSize:13.f];
        Momentary.x =CGRectGetMaxX(modeSwitch.frame) + margin/2;
        Momentary.y = topMargin + (margin+height)*index;
        Momentary.width = self.view.width - Momentary.x;
        Momentary.text = @"Momentary";
        Momentary.textColor = [UIColor whiteColor];
        [_modeScrollView addSubview:Momentary];
    }
    
    UIView *lastMode = _modeScrollView.subviews.lastObject;
    _modeScrollView.contentSize = CGSizeMake(self.view.width, CGRectGetMaxY(lastMode.frame)+margin+60);
}

-(BOOL)textField:(UITextField *)textField shouldChangeCharactersInRange:(NSRange)range replacementString:(NSString *)string{
    NSCharacterSet *cs;
    cs = [[NSCharacterSet characterSetWithCharactersInString:kAlphaNum]invertedSet];
    NSString *filtered = [[string componentsSeparatedByCharactersInSet:cs]componentsJoinedByString:@""];
    BOOL canChange = [string isEqualToString:filtered];
    
    NSString * toBeString = [textField.text stringByReplacingCharactersInRange:range withString:string];
    
    if(toBeString.length>7){
        textField.text = [toBeString substringToIndex:7];
        canChange = NO;
    }
    return canChange;
}

- (void)onBack{
    int index = 100;
    for (; index<112; index++) {
        UITextField *re1 = (UITextField*)[self.nameScrollView viewWithTag:index];
        UISwitch *swi = (UISwitch*)[self.modeScrollView viewWithTag:index];
        NSString *namekey = [NSString stringWithFormat:@"name%d",index];
        NSString *modekey = [NSString stringWithFormat:@"mode%d",index];
        [[NSUserDefaults standardUserDefaults] setValue:re1.text forKey:namekey];
        [[NSUserDefaults standardUserDefaults] setBool:swi.isOn forKey:modekey];
    }
    [delegate onModify];
    [self dismissViewControllerAnimated:YES completion:nil];
}


- (void)viewWillAppear:(BOOL)animated
{
    [super viewWillAppear:animated];
    [self.navigationController setNavigationBarHidden:NO animated:YES];
}


-(void)keyboardDidChangeFrame:(NSNotification *)noti
{
    NSDictionary *userInfo = [noti userInfo];
    NSValue *aValue = [userInfo objectForKey:UIKeyboardFrameEndUserInfoKey];
    CGRect keyboardRect = [aValue CGRectValue];
    CGRect frame = [activeTextField convertRect:activeTextField.bounds toView:nil];
    CGFloat maxY = CGRectGetMaxY(frame);
    CGFloat keyBoardY = self.view.height - keyboardRect.size.height;
    CGFloat offset = maxY - keyBoardY ;
    [UIView animateWithDuration:0.4 animations:^{
        self.nameScrollView.contentOffset = CGPointMake(0, offset<=0?orightOffset:offset+orightOffset);
    }];

}


- (BOOL)textFieldShouldBeginEditing:(UITextField *)textField
{
    return YES;
}

- (void)textFieldDidBeginEditing:(UITextField *)textField
{
    activeTextField = textField;
    isShowKeyboard = YES;
}

- (void)textFieldDidEndEditing:(UITextField *)textField
{
    activeTextField =nil;
    isShowKeyboard = NO;
}

- (BOOL)textFieldShouldReturn:(UITextField *)textField
{
    [textField resignFirstResponder];
    activeTextField =nil;
    isShowKeyboard = NO;
    return NO;
}

- (void)scrollViewDidScroll:(UIScrollView *)scrollView
{
    if(scrollView==_nameScrollView){
        if(!isShowKeyboard){
            orightOffset = scrollView.contentOffset.y;
        }
    }else if(scrollView==_mainScrollView){
        CGFloat offsetX = scrollView.contentOffset.x;
        if(offsetX==0){
            self.title = @"Name";
        }else if(offsetX == self.view.width){
            self.title = @"Mode";
        }
    }
}


@end
